//+------------------------------------------------------------------+
//|                                                    Iwe-EA 01.mq4 |
//|                                            Copyright  2006, Iwe |
//|                                     http://www.johansetiawan.net |
//|                                           @: iwe4email@yahoo.com |
//|                                          YM: iwe4email           |
//|                                         MSN: iwe4email@yahoo.com |
//+------------------------------------------------------------------+

#property copyright "Copyright  2006, Iwe"
#property link      "http://www.johansetiawan.net"

int IDno = 14999;
string IDtxt = "EA_ParSar";

//------------------------------------------------------------------\\

extern double step=0.02; //step for ParSar
extern double max=0.2; //max for ParSar

extern double Lots=0.1; //Lot
extern int Slippage=5; //slippage

extern int StopLoss=50; //SL
extern int TakeProfit=200; //TP
extern int TrailingStop=30; //Trailing
extern int ranging=50; //Ranging
extern int trev=4; //number of tolerated reversal
extern bool trademidnight=false; //is this EA active at midnight ?

//from pivot lines
double day_high=0;
double day_low=0;
double yesterday_high=0;
double yesterday_open=0;
double yesterday_low=0;
double yesterday_close=0;
double today_open=0;
double today_high=0;
double today_low=0;
double rates_d1[2][6];

double P=0;
double Q=0;
double D=0;
double R1,R2,R3;
double S1,S2,S3;
double nQ=0;
double nD=0;
//==================================

//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
   

void start()
{   
   Print ("EA Started..... waiting for aproval");
   Print("EA OK, Started");
   
   
   //PIVOT
   //---- Get new daily prices
	ArrayCopyRates(rates_d1, Symbol(), PERIOD_D1);

	yesterday_close = rates_d1[1][4];
	yesterday_open = rates_d1[1][1];
	today_open = rates_d1[0][1];
	yesterday_high = rates_d1[1][3];
	yesterday_low = rates_d1[1][2];
	day_high = rates_d1[0][3];
	day_low = rates_d1[0][2];
	
	D = (day_high - day_low);
	Q = (yesterday_high - yesterday_low);
	P = (yesterday_high + yesterday_low + yesterday_close) / 3;
	R1 = (2*P)-yesterday_low;
	S1 = (2*P)-yesterday_high;
	R2 = P+(yesterday_high - yesterday_low);
	S2 = P-(yesterday_high - yesterday_low);
	R3 = (2*P)+(yesterday_high-(2*yesterday_low));
	S3 = (2*P)-((2* yesterday_high)-yesterday_low);

	if (Q > 5) {
		nQ = Q;
	} else {
		nQ = Q*10000;
	}

	if (D > 5) {
		nD = D;
	} else {
		nD = D*10000;
	}
	
	//==============================================
	
   int totalorder=0;
   int cnt, tot, total;
   tot=OrdersTotal();
   total=0;
   int tiket;
   int hournow;
   int a,b,c;
   int totalreversal=0;
   bool sarlatest=true;  //true=diatas
   bool sarnow=true;
   double SL,TP;
   
   for(cnt=0;cnt<tot;cnt++)
   {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if(OrderSymbol()==Symbol() &&  ( OrderType()==OP_BUY || OrderType()==OP_SELL ))
      {
         total++; 
      }  
   }
   if (Hour()>=9 || Hour()<2) //active only  7.00 GMT - 0.00 GMT
   {
      //Print("EA Active");
      if (total==0) //jika tidak ada order
      {
         if (Hour()>=9 || Hour()<13) //afternoon : 7 GMT - 11 GMT
         {
            if (revNoon(step,max,trev))
            {
               if (day_high-day_low>ranging*Point) // check day range
               {
                  openPos(StopLoss,TakeProfit,Lots,Slippage,IDtxt,IDno); //open position
               }
            }
         }
         if (Hour()>=13 || Hour()<19) //evening : 11 GMT - 17 GMT
         {
            if (revEvening(step,max,trev))
            {
               if (day_high-day_low>ranging*Point) // check day range
               {
                  openPos(StopLoss,TakeProfit,Lots,Slippage,IDtxt,IDno); //open position
               }
            }
         }
      }
      else if (total>0) //kalau ada order
      {
         OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
         if ( ( OrderType()==OP_BUY && ( iSAR(NULL,0,step,max,0) > High[0]))  ||
              ( OrderType()==OP_SELL && ( iSAR(NULL,0,step,max,0) < Low[0])) )
         {
            Print("Reversal..... closing position");
            OrderClose(OrderTicket(),OrderLots(),Bid,Slippage,Violet);
         }
         else //no reversal
         {
            double entry=OrderOpenPrice();
            double askskg=Ask; //harga tinggi
            double bidskg=Bid; //harga rendah
            double profit;
            double sl,tp;
            
            if (OrderType()==OP_SELL)
            {
               profit=(entry-askskg)/Point;
               
               if (profit>=40 && profit<70) //profit 40
               {
                  sl=entry;
                  OrderModify(OrderTicket(),OrderOpenPrice(),sl,OrderTakeProfit(),0,Orange);
               }
               else if (profit>=70 && profit<100) //profit 70
               {
                  sl=entry-40*Point;
                  OrderModify(OrderTicket(),OrderOpenPrice(),sl,OrderTakeProfit(),0,Orange);
               }
               else if (profit>=100 && profit<130) //profit 100
               {
                  sl=entry-70*Point;
                  OrderModify(OrderTicket(),OrderOpenPrice(),sl,OrderTakeProfit(),0,Orange);
               }
               else if (profit>=130 ) //profit 130
               {
                  sl=Ask+TrailingStop*Point;
                  OrderModify(OrderTicket(),OrderOpenPrice(),sl,OrderTakeProfit(),0,Orange);
               }
            }  
            else if (OrderType()==OP_BUY)
            {
               profit=(bidskg-entry)/Point;
               if (profit>=40 && profit<70) //profit 40
               {
                  sl=entry;
                  OrderModify(OrderTicket(),OrderOpenPrice(),sl,OrderTakeProfit(),0,Orange);
               }
               
               else if (profit>=70 && profit<100) //profit 70
               {
                  sl=entry+40*Point;
                  OrderModify(OrderTicket(),OrderOpenPrice(),sl,OrderTakeProfit(),0,Orange);
               }
               else if (profit>=100 && profit<130) //profit 100
               {
                  sl=entry+70*Point;
                  OrderModify(OrderTicket(),OrderOpenPrice(),sl,OrderTakeProfit(),0,Orange);
               }
               
               else if (profit>=130 ) //profit 130+
               {
                  sl=Bid-TrailingStop*Point;
                  OrderModify(OrderTicket(),OrderOpenPrice(),sl,OrderTakeProfit(),0,Orange);
               }
            }    
         } //end no reversal 
      } //end no order
   }//end active hour 
   else
   {
      if (!trademidnight) 
      {
         if (OrdersTotal()>0)
         {
            Print("This is midnight : Closing all open position");
            OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
            OrderClose(OrderTicket(),OrderLots(),Bid,Slippage,Violet);
         }
      }
   }
   return (0);
} //end init
 
bool revNoon(int step, int max, int trev) //count how much reversal since 12.00
{
   int hournow=Hour()-6;
   int totalreversal=0;
   bool sarlatest=true;  //true=dot is higher than price
   bool sarnow=true;
   for (int a=0;a<=hournow;a++)
   {
      if(iSAR(NULL,0,step,max,a) > High[a])
      {
         sarnow=true;     
      }
      else if(iSAR(NULL,0,step,max,a) <= High[a])
      {
         sarnow=false;     
      } 
      if(sarnow!=sarlatest)
      {
         totalreversal++;
         sarlatest=sarnow;
      }
   }
   if (totalreversal>trev)  
   {
      return (false);
   }
   else
   {  
      return (true);
   }   
}

bool revEvening(int step, int max, int trev)
{
   int hournow=Hour();
   if (hournow<15) 
   { 
      hournow=hournow+24; 
   }
   hournow=hournow-15;
   
   int totalreversal=0;
   bool sarlatest=true;  
   bool sarnow=true;
   for (int a=0;a<=hournow;a++)
   {
      if (iSAR(NULL,0,step,max,a) >= High[a])
      {
         sarnow=true;  
      }
      else if (iSAR(NULL,0,step,max,a) <= High[a])
      {
         sarnow=false;    
      } 
      if (sarnow!=sarlatest)
      {
         totalreversal++;
         sarlatest=sarnow;
      }       
   }
   if (totalreversal>trev)  
   {
      return (false);
   }
   else
   {  
      return (true);
   }   
}

void openPos(int StopLoss, int TakeProfit,double Lots, int Slippage, string IDtxt, int IDno)
{
   //openparsar
   double SL,TP;
   int tiket;
   if (iSAR(NULL,0,step,max,0) >= High[0]  ) //parsar diatas
   {
      if (StopLoss>0) SL=Bid+StopLoss*Point; else SL=0;
      if (TakeProfit>0) TP=Ask-TakeProfit*Point; else TP=0;
      Print("Opening a sell position......");
      tiket=OrderSend(Symbol(),OP_SELL,Lots,Bid,Slippage,SL,TP,IDtxt,IDno,0,Orange);
      if(tiket>0)
        {
            if(OrderSelect(tiket,SELECT_BY_TICKET,MODE_TRADES)) Print("SELL order opened : ",OrderOpenPrice());
            //PlaySound(suaraBukaPosisi);
        }
      else 
        {
            Print("Error opening SELL order : ",GetLastError());  
            //PlaySound(suaraError);
        }
      //return(0); 
   }

   if ( iSAR(NULL,0,step,max,0) <= Low[0]   ) //parsar dibawah
   {
      if (StopLoss>0) SL=Ask-StopLoss*Point; else SL=0;
      if (TakeProfit>0) TP=Bid+TakeProfit*Point; else TP=0;
      Print("Opening a buy position......");
      tiket=OrderSend(Symbol(),OP_BUY,Lots,Ask,Slippage,SL,TP,IDtxt,IDno,0,Red);
      if(tiket>0)
      {
           if(OrderSelect(tiket,SELECT_BY_TICKET,MODE_TRADES)) Print("BUY order opened : ",OrderOpenPrice());
           // PlaySound(suaraBukaPosisi);

      }
      else 
      {
         Print("Error opening BUY order : ",GetLastError()); 
        // PlaySound(suaraError);
      }
      //return(0); 
   }
}